package com.example.takeawaysystemserver.controller;

import com.example.takeawaysystemserver.entity.Dish;
import com.example.takeawaysystemserver.entity.Shop;
import com.example.takeawaysystemserver.service.ShopService;
import com.example.takeawaysystemserver.util.R;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author Ethereal
 * @date 2024/7/12
 * @description
 */
@RestController
@RequestMapping("shop")
@Api(tags = "商家模块")
public class ShopController {

    @Resource
    private ShopService shopService;


    @GetMapping("get-all-shop")
    @ApiOperation(value = "获取所有商家的菜品信息")
    public R<List<Shop>> getAllShop(){
        return shopService.getAllShop();
    }

    @GetMapping("get-shop-dishes")
    @ApiOperation(value = "获取某个商家的所有菜品信息（包括口味）")
    public R<List<Dish>> getAllDishes(@RequestParam("id") Integer id){
        return shopService.getShopDishes(id);
    }

    @GetMapping("search-keyword")
    @ApiOperation(value = "根据关键字搜索商家")
    public R<List<Shop>> searchByKeyword(@RequestParam("keyword")String keyword){
        return shopService.search(keyword);
    }
}
